import java.io.File;
import java.io.FileOutputStream;

import javax.swing.SwingUtilities;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/*
 * Created on 2006/02/24
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class MakeTMS extends MakeTemplate {

	public MakeTMS(String p_filename, String p_path, SBDTableModel p_model,
			DialogProgress p_dlg) {
		super(p_filename, p_path, p_model, p_dlg);
		model.removeSpace();		// ̗]vȃXy[X͍폜̂͌ʃNX
	}

	int getBlankX(){
		return 640;
	}

	int getBlankY(){
		if(model.getIconMode() == SBDTableModel.ICON_WIDE){
			return 360;
		}else{
			return 480;
		}
	}

	String getBlankImageFileName() throws Exception{
		logger.info("execPath="+execPath);
		String blankimage;
		if(model.getIconMode() == SBDTableModel.ICON_WIDE){
			blankimage =
				execPath
					+ "img"
					+ File.separator
					+ "640_360.png";
		}else{
			blankimage =
				execPath
					+ "img"
					+ File.separator
					+ "640_480.png";
		}
		File f=new File(blankimage);
		if(f.getAbsoluteFile().exists() == false ){
			throw new Exception("Blank Image Not Fond. file="+blankimage );
		}
		blankimage = f.getCanonicalPath();
		return blankimage ;
	}


	@Override
	void exec() {
		if(fileName==null){
			return;
		}
		if(fileName.length() <= 0){
			return;
		}

		// DOM쐬
		try{
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document retdoc = builder.newDocument(); // Create from whole cloth
			
			// rootGg<tms>
			Element root = (Element) retdoc.createElement("tms");
			root.setAttribute("xmlns","http://www.mapletown.net/~nekora/tms");
			retdoc.appendChild(root);

			Element e;
			// <vesion>
			e = (Element) retdoc.createElement("version");
			e.setAttribute("number","1.0");
			root.appendChild(e);

			// context
			e = (Element) retdoc.createElement("context");
			e.setAttribute("sizex", Integer.toString( getBlankX() )  );
			e.setAttribute("sizey", Integer.toString( getBlankY() ));
			e.setAttribute("framerate",  Integer.toString(model.frameRate) );
			root.appendChild(e);
			
			//option Ȃ
			e = (Element) retdoc.createElement("option");
			e.setAttribute("xmlns","http://www.mapletown.net/~nekora/tms/option");
			root.appendChild(e);
			
			Element e2,  e3;
			//material
			e = (Element) retdoc.createElement("material");
			e.setAttribute("xmlns","http://www.mapletown.net/~nekora/tms/material");
			root.appendChild(e);

			// material/layer
			e2 = (Element) retdoc.createElement("layer");
			e2.setAttribute("name","L1");
			e2.setAttribute("comment","PꃌC");
			e.appendChild(e2);

			// material/layer/img ... img͕
			String save_dst=getBlankImageFileName(); // PŐ̉摜
			for(int i=0; i<model.getRowCount(); i++  ){
				e3 = (Element) retdoc.createElement("img");
				String imgfilename = model.getImgNameAt(i);
				String comment=null;
				if(imgfilename != null && imgfilename.length()>0){
					File f = new File(imgfilename);
					if(f.getAbsoluteFile().exists()){
						if(f.isDirectory()){
							imgfilename = save_dst;
							comment = "(fBNg)" ;
						}else{
							imgfilename = f.getCanonicalPath();
						}
					}else{
						imgfilename = getBlankImageFileName();
						comment= "wt@CȂB󔒂ɒu"+imgfilename;
					}
					save_dst = imgfilename;
				}else{
					imgfilename = save_dst;
					comment = "(null)" ;
				}
				/**
				String reg = File.separator  +File.separator  +"\\."+File.separator  +File.separator  ;
				logger.info("regexp="+reg);
				imgfilename = imgfilename.replaceAll(reg,"\\");
				**/
				logger.info("imgfilename="+imgfilename);
				//e3.setAttribute("src", "file:"+ imgfile );
				e3.setAttribute("src", imgfilename );
				if(comment != null){
					e3.setAttribute("comment", comment );
				}
				
				e2.appendChild(e3);
			}
			
			// format
			e = (Element) retdoc.createElement("format");
			e.setAttribute("xmlns","http://www.mapletown.net/~nekora/tms/format");
			root.appendChild(e);
			
			// format/peg
			e2 = (Element) retdoc.createElement("peg");
			e2.setAttribute("name","P1");
			e2.setAttribute("mode","normal");
			e.appendChild(e2);
			
			// format/peg/layer
			e3 = (Element) retdoc.createElement("layer");
			e3.setAttribute("name", "L1"); // L1̂݌Œ
			e2.appendChild(e3);

			// script
			e = (Element) retdoc.createElement("script");
			e.setAttribute("bgcolor","#ffffff");
			e.setAttribute("xmlns","http://www.mapletown.net/~nekora/tms/script");
			root.appendChild(e);

			// script/piece .. (̐)
			for(int i=0; i<model.getRowCount(); i++  ){
				e2 = (Element) retdoc.createElement("piece");
				e.appendChild(e2);
				
				// script/piece/peg
				e3 = (Element) retdoc.createElement("peg");
				e3.setAttribute("name","P1");
				e2.appendChild(e3);
				
				// script/piece/peg/layer
				Element e4;
				e4 = (Element) retdoc.createElement("layer");
				e4.setAttribute("name","L1");
				e4.setAttribute("number", Integer.toString(i) );
				e3.appendChild(e4);
		
				// vOXo[i߂
				try{
					prog = i;
					SwingUtilities.invokeLater(updateAComponent);
				}catch(Exception ex){
					logger.warning(ex.toString());
				}

			}
			// documentxmlăt@Co
			TransformerFactory transFactory =
				TransformerFactory.newInstance();
			Transformer transformer = transFactory.newTransformer();
			transformer.setOutputProperty("indent", "yes");// ɃCfg
			
			DOMSource source = new DOMSource(retdoc);
			File newXML = new File(fileName);
			FileOutputStream os = new FileOutputStream(newXML);
			StreamResult result = new StreamResult(os);
			transformer.transform(source, result);   // DOMXSLTŃXg[Ɍ
			os.flush();
			os.close();
			
			//e.appendChild(retdoc.createTextNode(title));
		}catch(Exception e){
			logger.warning(e.toString() );
			return;
		}
	}

}
