import java.awt.Point;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Locale;
import java.util.logging.Logger;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;

	class SBDTable extends JTable implements DropTargetListener {
		private static final long serialVersionUID = 1L;
		private SBDTableModel model;
		private JLabel statusBar;
		private Logger logger;
		private Locale lang;
		private String formatStr;

		SBDTable(SBDTableModel m, JLabel s, Locale lng, Logger l) {
			super((javax.swing.table.TableModel) m);
			new DropTarget(this, this);
			model = m;
			statusBar = s;
			lang = lng;
			logger = l;
			if(lang==Locale.JAPANESE){
				formatStr="%dsځc%d/%dy[W";
			}else{
				formatStr="Line:%d About %d/%d page";
			}
		};

		// 2008/4/3 ǉBIsς邽тɃXe[^Xo[ɕ`
		public void valueChanged(ListSelectionEvent e){
			super.valueChanged(e);
			try{
				int line = getSelectedRow();
				double pgf=line/ model.getLinesParPage() +0.5; // ľܓ
				long pg = Math.round(pgf);
				int max = getRowCount()/model.getLinesParPage();
				//String sts = (line+1)+"sځc"+pg+"/"+max+"y[W";
				String sts=String.format(lang, formatStr, (line+1),	pg,max );
				statusBar.setText(sts);
			}catch(Exception ex){
				logger.warning("Xe[^Xo[`掸s "+ex.toString());
			}
		}

		// D&D\bh
		/**
		 * hbOhbvihbvjCxgp\bhłD
		 * hbO삪hbvŏIƂɌĂяo܂D
		 *
		 * @param dte hbOhbvCxg
		 */
		public void drop(DropTargetDropEvent dtde) {
			try {
				// ]ꂽf[^̎擾
				Transferable tr = dtde.getTransferable();
				// ]f[^T|[g\ȃf[^ǂ
				if (tr.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {
					// hbv󂯓
					dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);

					// ]f[^t@C̃Xg𒊏o
					java.util.List myList =
						(java.util.List) tr.getTransferData(
							DataFlavor.javaFileListFlavor);
					// XgvfPꂩǂ
					if (myList.size() >= 1) {
						// Xgt@C̎o
						File myFile = (File) myList.get(0);
						// t@C̐΃pX\
						// ۂɂ́ĈPsύXƗǂ
						//logger.info(myFile.getAbsolutePath());
						Point p = dtde.getLocation();
						//logger.info("Point="+p.toString());
						int row = rowAtPoint( p );
						//int column = columnAtPoint( p );
						//logger.info("Row="+row+" Column="+column);
						model.setValueAt(myFile.getCanonicalPath(), row, 1);
						//model.setEditing();

						if(myList.size()>1){
							ArrayList<String> al = new ArrayList<String>();
							int cnt=0;
							// t@Cꗗ擾
							for(int i=1; i<myList.size(); i++){
								myFile = (File) myList.get(i);
								if(row+i < model.getRowCount()){

									al.add( myFile.getCanonicalPath() );
									// logger.info("1st tmplist["+cnt+"]="+  );
								}else{
									//tmplist[cnt]="";
									break;
								}
							}
							// t@CŃ\[g
							Object[] tmplist = al.toArray();
							logger.info( "Len="+tmplist.length  );
							java.util.Arrays.sort( tmplist );
							// Zbg
							cnt=0;
							for(int i=1; i<myList.size() ; i++){
								if(row+i < model.getRowCount()){
									model.setValueAt( (String)tmplist[ cnt ], row+i, 1);
									logger.info("2nd tmplist["+cnt+"]="+ (String)tmplist[cnt] );
									cnt ++;
								}else{
									break;
								}
							}
						}

						// hbv𐳏I
						dtde.getDropTargetContext().dropComplete(true);
					} else {
						// uvfvƂx\
						logger.info("Invalid size.");
						// hbvُI
						dtde.getDropTargetContext().dropComplete(false);
					}
				} else {
					logger.info("Unsupported.");
					// hbv͂˂
					dtde.rejectDrop();
				}
			} catch (IOException ioe) {
				logger.info("I/O exception.");
				// hbv͂˂
				dtde.rejectDrop();
			} catch (UnsupportedFlavorException ufe) {
				logger.info("Unsupported");
				// hbv͂˂
				dtde.rejectDrop();
			}
		}
		/**
		  * hbOhbvihbvjCxgp\bhłD
		  * hbOoƂɌĂяo܂D
		  *
		  * @param dtde hbOhbvCxg
		  */
		public void dragEnter(DropTargetDragEvent dtde) {
			dtde.acceptDrag(DnDConstants.ACTION_COPY);
		}

		/**
		 * hbOhbvihbvjCxgp\bhłD
		 * hbO삪hbvȂ̂ƂɌĂяo܂D
		 *
		 * @param dte hbOhbvCxg
		 */
		public void dragExit(DropTargetEvent dte) {
		}

		/**
		 * hbOhbvihbvjCxgp\bhłD
		 * hbO삪iŝƂɌĂяo܂D
		 *
		 * @param dte hbOhbvCxg
		 */
		public void dragOver(DropTargetDragEvent dtde) {
		}

		/**
		 * hbOhbvihbvjCxgp\bhłD
		 * [Ũ݂hbvWFX`[ύXƂɌĂяo܂D
		 *
		 * @param dte hbOhbvCxg
		 */
		public void dropActionChanged(DropTargetDragEvent dtde) {
		}

	};